package com.rabbitmq.tutorials.chap05;

import com.rabbitmq.client.BuiltinExchangeType;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;

public class EmitLogTopic {

	public static void main(String[] argv) {
		System.out.println(Constants.HEADER);
		String rabbitmqHost = "localhost";
		
		ConnectionFactory factory = new ConnectionFactory();
		factory.setHost(rabbitmqHost);
		
		try {
			// 서버연결
			Connection connection = factory.newConnection();
			
			// 채널생성	
			Channel channel = connection.createChannel();
			
			// EXCHANGE생성
			channel.exchangeDeclare(Constants.EXCHANGE_NAME, BuiltinExchangeType.TOPIC);
			
			String routingKey = getRoutingkey(argv);
			String message = getMessage(argv);
		
			channel.basicPublish(Constants.EXCHANGE_NAME, routingKey, null, message.getBytes("UTF-8"));
			System.out.println(" [x] Sent '" + routingKey + "':'" + message + "'");
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static String getRoutingkey(String[] strings) {
		if (strings.length < 1)
			return "anonymous.info";
		
		return strings[0];
	}

	private static String getMessage(String[] strings) {
		if (strings.length < 2) 
			return "Hello World!";
					
		return joinStrings(strings, " ", 1);
	}
	
	private static String joinStrings(String[] strings, String delimeter, int startIndex) {
		int length = strings.length;
		if (length == 0) return "";
		if (length <= startIndex) return "";
		StringBuilder words = new StringBuilder(strings[startIndex]);
		for (int i = startIndex + 1; i < length; i++) {
			words.append(delimeter).append(strings[i]);
		}
		return words.toString();
	}
}
